package com.eleith.calchoochoo.utils;

import android.content.Context;
import android.os.Handler;
import android.support.design.widget.CoordinatorLayout;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.view.ViewCompat;
import android.util.AttributeSet;
import android.util.Log;
import android.view.View;
import android.view.animation.LinearInterpolator;

public class FabScrollingBehavior extends CoordinatorLayout.Behavior<FloatingActionButton> {
  private static final String TAG = "ScrollingFABBehavior";
  Handler mHandler;

  public FabScrollingBehavior(Context context, AttributeSet attrs) {
    super();
  }

  @Override
  public void onStopNestedScroll(CoordinatorLayout coordinatorLayout, final FloatingActionButton child, View target) {
    super.onStopNestedScroll(coordinatorLayout, child, target);

    if (mHandler == null)
      mHandler = new Handler();


    mHandler.postDelayed(new Runnable() {
      @Override
      public void run() {
        child.animate().translationY(0).setInterpolator(new LinearInterpolator()).start();
      }
    },1500);
  }

  @Override
  public void onNestedScroll(CoordinatorLayout coordinatorLayout, FloatingActionButton child, View target, int dxConsumed, int dyConsumed, int dxUnconsumed, int dyUnconsumed) {
    super.onNestedScroll(coordinatorLayout, child, target, dxConsumed, dyConsumed, dxUnconsumed, dyUnconsumed);

    if (dyConsumed > 0) {
      CoordinatorLayout.LayoutParams layoutParams = (CoordinatorLayout.LayoutParams) child.getLayoutParams();
      int fab_bottomMargin = layoutParams.bottomMargin;
      child.animate().translationY(child.getHeight() + fab_bottomMargin).setInterpolator(new LinearInterpolator()).start();
    } else if (dyConsumed < 0) {
      child.animate().translationY(0).setInterpolator(new LinearInterpolator()).start();
    }
  }

  @Override
  public boolean onStartNestedScroll(CoordinatorLayout coordinatorLayout, FloatingActionButton child, View directTargetChild, View target, int nestedScrollAxes) {
    if(mHandler!=null) {
      mHandler.removeMessages(0);
    }
    return nestedScrollAxes == ViewCompat.SCROLL_AXIS_VERTICAL;
  }
}
